/*## (c) SECURITY EXPLORATIONS    2011 poland                                #*/
/*##     http://www.security-explorations.com                                #*/

/* RESEARCH MATERIAL:	SRP-2018-01                                           */
/* SlimCORE tracer                                                            */

/* THIS SOFTWARE IS PROTECTED BY DOMESTIC AND INTERNATIONAL COPYRIGHT LAWS    */
/* UNAUTHORISED COPYING OF THIS SOFTWARE IN EITHER SOURCE OR BINARY FORM IS   */
/* EXPRESSLY FORBIDDEN. ANY USE, INCLUDING THE REPRODUCTION, MODIFICATION,    */
/* DISTRIBUTION, TRANSMISSION, RE-PUBLICATION, STORAGE OR DISPLAY OF ANY      */
/* PART OF THE SOFTWARE, FOR COMMERCIAL OR ANY OTHER PURPOSES REQUIRES A      */
/* VALID LICENSE FROM THE COPYRIGHT HOLDER.                                   */

/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    */
/* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,*/
/* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    */
/* SECURITY EXPLORATIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, */
/* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF  */
/* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE     */
/* SOFTWARE.                                                                  */

import java.lang.*;

public class STTKDMADebug {
 public static final int DATA_OFF   = Config.TRACER_DATA;
 public static final int CODE_OFF   = Config.TRACER_CODE;

 public static final int CODE_ADDR  = Config.STTKDMA_BASE+Config.STTKDMA_CODE;
 public static final int DATA_ADDR  = Config.STTKDMA_BASE+Config.STTKDMA_DATA;

 public static final int R1_OFF     = 0x00;
 public static final int R2_OFF     = 0x01;
 public static final int R3_OFF     = 0x02;
 public static final int R4_OFF     = 0x03;
 public static final int R5_OFF     = 0x04;
 public static final int R6_OFF     = 0x05;
 public static final int R7_OFF     = 0x06;
 public static final int R8_OFF     = 0x07;
 public static final int R9_OFF     = 0x08;
 public static final int R10_OFF    = 0x09;
 public static final int R11_OFF    = 0x0a;
 public static final int R12_OFF    = 0x0b;
 public static final int R13_OFF    = 0x0c;
 public static final int R14_OFF    = 0x0d;

 public static final int DUMMY_OFF  = 0x0e;
 public static final int STATUS_OFF = 0x0f;
 public static final int CMD_OFF    = 0x10;

 public static final int BFLAG1_OFF  = 0x11;
 public static final int BFLAG2_OFF  = 0x12;
 public static final int BFLAG3_OFF  = 0x13;

 public static final int INS_OFF     = CODE_OFF+(0x05d9-0x5b7);
 public static final int BRANCH1_OFF = CODE_OFF+(0x05df-0x5b7);
 public static final int BRANCH2_OFF = CODE_OFF+(0x05e1-0x5b7);
 public static final int BRANCH3_OFF = CODE_OFF+(0x05e3-0x5b7);

 public static final int BREAK      = 0x00d00010|((CODE_OFF&0xff0)<<4)|(CODE_OFF&0x0f);
 public static final int NOP        = 0x00b00000|(((DATA_OFF>>2)+DUMMY_OFF)&0xff);

 public static final int WAIT_TIME  = 2;

 private static int regs[];
 private static int PC;

 public static int code[]={
  0x00b01050,//   st r1,[r0,0050] offset 0x05b7 idx 0
  0x00b02051,//   st r2,[r0,0051] offset 0x05b8 idx 1
  0x00b03052,//   st r3,[r0,0052] offset 0x05b9 idx 2
  0x00b04053,//   st r4,[r0,0053] offset 0x05ba idx 3
  0x00b05054,//   st r5,[r0,0054] offset 0x05bb idx 4
  0x00b06055,//   st r6,[r0,0055] offset 0x05bc idx 5
  0x00b07056,//   st r7,[r0,0056] offset 0x05bd idx 6
  0x00b08057,//   st r8,[r0,0057] offset 0x05be idx 7
  0x00b09058,//   st r9,[r0,0058] offset 0x05bf idx 8
  0x00b0a059,//   st r10,[r0,0059] offset 0x05c0 idx 9
  0x00b0b05a,//   st r11,[r0,005a] offset 0x05c1 idx 10
  0x00b0c05b,//   st r12,[r0,005b] offset 0x05c2 idx 11
  0x00b0d05c,//   st r13,[r0,005c] offset 0x05c3 idx 12
  0x00b0e05d,//   st r14,[r0,005d] offset 0x05c4 idx 13
  0x00b0005f,//   st r0,[r0,005f] offset 0x05c5 idx 14

  0x00a50060,//   ld r5,[r0,0060] offset 0x05c6 idx 15
  0x00c05000,//   cmp r5,#00 offset 0x05c7 idx 16
  0x009815c6,//   je  0x05c6  offset 0x05c8 idx 17
  0x00b0005e,//   st r0,[r0,005e] offset 0x05c9 idx 18

  0x00b00060,//   st r0,[r0,0060] offset 0x05ca idx 19

  0x00a10050,//   ld r1,[r0,0050] offset 0x05cb idx 20
  0x00a20051,//   ld r2,[r0,0051] offset 0x05cc idx 21
  0x00a30052,//   ld r3,[r0,0052] offset 0x05cd idx 22
  0x00a40053,//   ld r4,[r0,0053] offset 0x05ce idx 23
  0x00a50054,//   ld r5,[r0,0054] offset 0x05cf idx 24
  0x00a60055,//   ld r6,[r0,0055] offset 0x05d0 idx 25
  0x00a70056,//   ld r7,[r0,0056] offset 0x05d1 idx 26
  0x00a80057,//   ld r8,[r0,0057] offset 0x05d2 idx 27
  0x00a90058,//   ld r9,[r0,0058] offset 0x05d3 idx 28
  0x00aa0059,//   ld r10,[r0,0059] offset 0x05d4 idx 29
  0x00ab005a,//   ld r11,[r0,005a] offset 0x05d5 idx 30
  0x00ac005b,//   ld r12,[r0,005b] offset 0x05d6 idx 31
  0x00ad005c,//   ld r13,[r0,005c] offset 0x05d7 idx 32
  0x00ae005d,//   ld r14,[r0,005d] offset 0x05d8 idx 33

  0x00d00090,//   ins1 offset 0x05d9 idx 34
  0x00d00090,//   ins2 offset 0x05da idx 35
  0x00d00090,//   ins3 offset 0x05db idx 36
  0x00d00090,//   ins4 offset 0x05dc idx 37
  0x00d00090,//   ins5 offset 0x05dd idx 38

  0x00d05b17,//   jmp 0x5b7 offset 0x05de idx 39

  //branch 1
  0x00b00061,//   st r0,[r0,0061] offset 0x05df idx 40
  0x00d05b17,//   jmp 0x5b7 offset 0x05e0 idx 41

  //branch 2
  0x00b00062,//   st r0,[r0,0062] offset 0x05e1 idx 42
  0x00d05b17,//   jmp 0x5b7 offset 0x05e2 idx 43

  //branch 3
  0x00b00063,//   st r0,[r0,0063] offset 0x05e3 idx 44
  0x00d05b17,//   jmp 0x5b7 offset 0x05e4 idx 45

  0x00b0005e //   st r0,[r0,005e] offset 0x05c9 idx 46
 };

 private static int wait_opcodes[]={
  0xfff000, 0x8e1000, //wait1
  0xfff000, 0x8d8000, //wait2
  0xfff000, 0x9e1000, //wait3
  0xfff000, 0x9d8000  //wait4
 };

 private static int jmp_opcode[]={
  0xff00f0, 0xd00010  //jmp
 };

 private static int jmp_reg_opcode[]={
  0xff0000, 0x840000  //jmp reg
 };

 private static int j_opcode[]={
  0xfff000, 0x8c0000  //j
 };

 private static int rpt_opcodes[]={
  0xfffff0, 0xd00000, //rpt
  0xffffff, 0xd01000  //rpt 16
 };

 private static int cond_opcodes[]={
  0xfff000, 0x981000, //je
  0xff0000, 0x880000, //jz, js
  0xfff000, 0x984000, //jb
  0xfff000, 0x9c4000, //jae
  0xfff000, 0x987000, //jbe
  0xfff000, 0x8c1000, //jne
  0xfff000, 0x9c1000, //jne
  0xfff000, 0x9c2000, //jns
  0xfff000, 0x8c0000, //j
  0xfff000, 0x982000, //js
  0xfff000, 0x983000, //jzs
  0xff0000, 0x9b0000, //jxx2
  0xff0000, 0x9a0000, //jxx3
  0xfff000, 0x8f2000, //jxx1
  0xfff000, 0x8e8000  //??
 };

 static boolean matching_opcode(int opcode,int defs[]) {
  for(int i=0;i<defs.length;i+=2) {
   if ((opcode&defs[i])==defs[i+1]) return true;
  }

  return false;
 }

 static boolean is_wait(int opcode) {
  return matching_opcode(opcode,wait_opcodes);
 }

 static boolean is_jmp(int opcode) {
  return matching_opcode(opcode,jmp_opcode);
 }

 static boolean is_jmp_reg(int opcode) {
  return matching_opcode(opcode,jmp_reg_opcode);
 }

 static boolean is_j(int opcode) {
  return matching_opcode(opcode,j_opcode);
 }

 static boolean is_rpt(int opcode) {
  return matching_opcode(opcode,rpt_opcodes);
 }

 static boolean is_conditional(int opcode) {
  return matching_opcode(opcode,cond_opcodes);
 }

 static void change_mem_imm(int idx,int loc) {
  int opcode=code[idx];
  code[idx]=(opcode&0xffffff00)|(loc&0xff);
 }

 static void change_jmp_target(int idx,int loc) {
  int opcode=code[idx];
  code[idx]=(opcode&0xffff00f0)|((loc&0xff0)<<4)|(loc&0x0f);
 }

 static void change_cond_target(int idx,int loc) {
  int opcode=code[idx];
  code[idx]=(opcode&0xfffff000)|(loc&0xfff);
 }

 static void prepare_core_routine() {
  for(int i=0;i<14;i++) {
   change_mem_imm(i,(DATA_OFF>>2)+i);
  }

  change_mem_imm(14,(DATA_OFF>>2)+STATUS_OFF);
  change_mem_imm(15,(DATA_OFF>>2)+CMD_OFF);

  change_cond_target(17,CODE_OFF+(0x05c6-0x5b7));
  change_mem_imm(18,(DATA_OFF>>2)+DUMMY_OFF);
  change_mem_imm(19,(DATA_OFF>>2)+CMD_OFF);

  for(int i=0;i<14;i++) {
   change_mem_imm(20+i,(DATA_OFF>>2)+i);
  }

  change_jmp_target(39,CODE_OFF);

  change_mem_imm(40,(DATA_OFF>>2)+BFLAG1_OFF);
  change_jmp_target(41,CODE_OFF);

  change_mem_imm(42,(DATA_OFF>>2)+BFLAG2_OFF);
  change_jmp_target(43,CODE_OFF);

  change_mem_imm(44,(DATA_OFF>>2)+BFLAG3_OFF);
  change_jmp_target(45,CODE_OFF);

  change_mem_imm(46,(DATA_OFF>>2)+DUMMY_OFF);
 }

 public static int get(int off) {
  return API.STTKDMA_READ(DATA_ADDR+DATA_OFF+4*off);
 }

 public static void set(int off,int val) {
  API.STTKDMA_WRITE(DATA_ADDR+DATA_OFF+4*off,val);
 }

 static {
  set(STATUS_OFF,-1);
  set(CMD_OFF,0);
  set(BFLAG1_OFF,-1);
  set(BFLAG2_OFF,-1);
  set(BFLAG3_OFF,-1);

  regs=new int[15];
  PC=-1;

  prepare_core_routine();

  for(int i=0;i<code.length;i++) {
   API.STTKDMA_WRITE(CODE_ADDR+4*(CODE_OFF+i),code[i]);
  }
 }

 private static void sleep(int num) {
  try {
   Thread.sleep(num);
  } catch(Throwable t) {}
 }

 private static void wait_status() {
  while(get(STATUS_OFF)!=0) {
   sleep(WAIT_TIME);
  }

  set(STATUS_OFF,-1);
 }

 private static void wait_break() {
  wait_status();
 }
 
 private static void wait_single_step_completed() {
  wait_status();
 }

 private static int exec_instruction() {
  int branch_taken=-1;

  set(CMD_OFF,1);
  wait_single_step_completed();

  if (get(BFLAG1_OFF)==0) {
   branch_taken=1;
   set(BFLAG1_OFF,-1);
  } else

  if (get(BFLAG2_OFF)==0) {
   branch_taken=2;
   set(BFLAG2_OFF,-1);
  } else

  if (get(BFLAG3_OFF)==0) {
   branch_taken=3;
   set(BFLAG3_OFF,-1);
  } else {
   branch_taken=0;
  }

  return branch_taken;
 }

 private static void save_regs() {
  for(int i=0;i<14;i++) {
   regs[1+i]=get(R1_OFF+i);
  }
 }

 private static String hex_value(int val,int max) {
  String s="";
  for(int i=0;i<max;i++) {
   s+="0";
  }

  s+=Integer.toHexString(val);

  return s.substring(s.length()-max);
 }

 private static void dump_regs() {
  String p1,p2,p3,p4,line;

  int r0=0;
  int r1=get(R1_OFF);
  int r2=get(R2_OFF);
  int r3=get(R3_OFF);
  int r4=get(R4_OFF);
  int r5=get(R5_OFF);
  int r6=get(R6_OFF);
  int r7=get(R7_OFF);
  int r8=get(R8_OFF);
  int r9=get(R9_OFF);
  int r10=get(R10_OFF);
  int r11=get(R11_OFF);
  int r12=get(R12_OFF);
  int r13=get(R13_OFF);
  int r14=get(R14_OFF);
  
  if (r0!=regs[0]) p1="*";
   else p1=" ";
  p1+="r0  "+hex_value(r0,8);

  if (r1!=regs[1]) p2="*";
   else p2=" ";
  p2+="r1  "+hex_value(r1,8);

  if (r2!=regs[2]) p3="*";
   else p3=" ";
  p3+="r2  "+hex_value(r2,8);

  if (r3!=regs[3]) p4="*";
   else p4=" ";
  p4+="r3  "+hex_value(r3,8);

  line=p1+" "+p2+" "+p3+" "+p4;
  API.LOG(line);

  if (r4!=regs[4]) p1="*";
   else p1=" ";
  p1+="r4  "+hex_value(r4,8);

  if (r5!=regs[5]) p2="*";
   else p2=" ";
  p2+="r5  "+hex_value(r5,8);

  if (r6!=regs[6]) p3="*";
   else p3=" ";
  p3+="r6  "+hex_value(r6,8);

  if (r7!=regs[7]) p4="*";
   else p4=" ";
  p4+="r7  "+hex_value(r7,8);

  line=p1+" "+p2+" "+p3+" "+p4;
  API.LOG(line);

  if (r8!=regs[8]) p1="*";
   else p1=" ";
  p1+="r8  "+hex_value(r8,8);

  if (r9!=regs[9]) p2="*";
   else p2=" ";
  p2+="r9  "+hex_value(r9,8);

  if (r10!=regs[10]) p3="*";
   else p3=" ";
  p3+="r10 "+hex_value(r10,8);

  if (r11!=regs[11]) p4="*";
   else p4=" ";
  p4+="r11 "+hex_value(r11,8);

  line=p1+" "+p2+" "+p3+" "+p4;
  API.LOG(line);

  if (r12!=regs[12]) p1="*";
   else p1=" ";
  p1+="r12 "+hex_value(r12,8);

  if (r13!=regs[13]) p2="*";
   else p2=" ";
  p2+="r13 "+hex_value(r13,8);

  if (r14!=regs[14]) p3="*";
   else p3=" ";
  p3+="r14 "+hex_value(r14,8);

  p4=" IP  "+hex_value(PC,8);

  line=p1+" "+p2+" "+p3+" "+p4;
  API.LOG(line);
 }

 public static void print_opcode(int ip) {
  int opcode=API.STTKDMA_READ(CODE_ADDR+4*ip);
  String ins=Opcode.ins_desc(opcode);

  String s=hex_value(ip,4)+"  0x"+hex_value(opcode,8)+"   "+ins;
  API.LOG(s);
 }

 public static void print_opcodes(int ip,int cnt) {
  for(int i=0;i<cnt;i++) {
   print_opcode(ip+i);
  }
 }

 public static void stop(int ip) {
  int saved_opcode=API.STTKDMA_READ(CODE_ADDR+4*ip);
  API.STTKDMA_WRITE(CODE_ADDR+4*ip,BREAK);
  wait_break();
  API.STTKDMA_WRITE(CODE_ADDR+4*ip,saved_opcode);

  PC=ip;

  API.LOG("break at: 0x"+hex_value(PC,8));
  dump_regs();
  print_opcode(PC);
  API.LOG("");

  save_regs();
 }

 private static int rewrite_opcode(int ip,int opcode,int num) {
  if (is_wait(opcode)) {
   opcode=(opcode&0xfffff000)|(ip&0xfff);
  } else

  if (is_conditional(opcode)) {
   int target=-1;

   switch(num) {
    case 1:
     target=BRANCH1_OFF;
     break;

    case 2:
     target=BRANCH2_OFF;
     break;

    case 3:
     target=BRANCH3_OFF;
     break;
   }

   opcode=(opcode&0xfffff000)|(target&0xfff);
  }

  return opcode;
 }

 private static void put_ins(int orgpc,int off,int opcode) {
  if (opcode!=NOP) print_opcode(orgpc);
  API.STTKDMA_WRITE(CODE_ADDR+4*off,opcode);
 }

 private static void stepi(boolean nowait) {
  int opcode=API.STTKDMA_READ(CODE_ADDR+4*PC);

  //by default translate as original instruction
  put_ins(PC,INS_OFF,opcode);
  put_ins(PC+1,INS_OFF+1,NOP);
  put_ins(PC+2,INS_OFF+2,NOP);
  put_ins(PC+3,INS_OFF+3,NOP);
  put_ins(PC+4,INS_OFF+4,NOP);

  /* wait opcode translation */
  if (is_wait(opcode)) {
   //translate as a wait instruction at INS_OFF location
   opcode=(opcode&0xfff000)|(INS_OFF&0xfff);

   if (nowait) put_ins(PC,INS_OFF,NOP);
    else put_ins(PC,INS_OFF,opcode);

   exec_instruction();
   PC=PC+1;
  } else

  /* jmp absolute opcode translation */
  if (is_jmp(opcode)) {
   int target=((opcode&0xff00)>>4)|(opcode&0x0f);

   //translate as a jump through branch1 code path
   opcode=0xd00010|((BRANCH1_OFF&0xff0)<<4)|(BRANCH1_OFF&0x0f);
   put_ins(PC,INS_OFF,opcode);

   exec_instruction();
   PC=target;
  } else

  /* jmp reg opcode translation */
  if (is_jmp_reg(opcode)) {
   int reg=(opcode&0xf00)>>8;
   int target=regs[reg];

   //translate as a jump through branch1 code path
   opcode=0xd00010|((BRANCH1_OFF&0xff0)<<4)|(BRANCH1_OFF&0x0f);
   put_ins(PC,INS_OFF,opcode);

   exec_instruction();
   PC=target;
  } else

  /* j always opcode translation */
  if (is_j(opcode)) {
   int target=opcode&0xfff;

   //translate as a jump through branch1 code path
   opcode=opcode&0xfffff000|(BRANCH1_OFF&0xfff);
   put_ins(PC,INS_OFF,opcode);

   exec_instruction();
   PC=target;
  } else

  /* rpt opcode translation */
  if (is_rpt(opcode)) {
   int opcode2=API.STTKDMA_READ(CODE_ADDR+4*(PC+1));

   //translate as a sequence of 2 instructions (rpt and the opcode
   //immediately following it)
   put_ins(PC,INS_OFF,opcode);
   put_ins(PC+1,INS_OFF+1,opcode2);

   exec_instruction();
   PC=PC+2;
  } else {
   //the number of instructions in a block to execute (1 by default)
   int cnt=1;

   //an instruction opcode following a current one
   int opcode2=API.STTKDMA_READ(CODE_ADDR+4*(PC+1));

   //is current instruction followed by a conditional instruction ?
   if (is_conditional(opcode2)) {
    //increase the number of instructions to execute
    cnt++;

    //check if there are more conditionals in a block of 5 instructions
    for(int i=cnt;i<5;i++) {
     opcode2=API.STTKDMA_READ(CODE_ADDR+4*(PC+i));
     if (is_conditional(opcode2)) cnt++;
      else break;
    }
 
    //initial index of a branch code path
    int bnum=1;

    //a table of possible targets for a given block of instructions
    int targets[]=new int[4];

    //default target in case of no conditional jump
    targets[0]=PC+cnt;

    //translate conditional jumps to go through one of 3 possible branch
    //code paths
    for(int i=0;i<cnt;i++) {
     opcode2=API.STTKDMA_READ(CODE_ADDR+4*(PC+i));

     if (is_conditional(opcode2)) {
      targets[bnum]=opcode2&0xfff;
      opcode2=rewrite_opcode(INS_OFF+i,opcode2,bnum);
      bnum++;
     } else {
      opcode2=rewrite_opcode(INS_OFF+i,opcode2,bnum);
     }
 
     put_ins(PC+i,INS_OFF+i,opcode2);
    }

    int idx=exec_instruction();

    //set PC location to either:
    //- the first instruction following a sequence of conditional jumps (idx 0)
    //- one of conditional jump targets (indices 1-3 depending ona branch taken)
    PC=targets[idx];
   } else {
    //next instruction is not a conditional, no translation needed for a current
    //one
    put_ins(PC,INS_OFF,opcode);

    exec_instruction();
    PC=PC+1;
   }
  }

  API.LOG("break at: 0x"+hex_value(PC,8));
  dump_regs();
  API.LOG("");

  save_regs();
 }

 public static void trace(int start_off) {
  stop(start_off);

  while(true) {
   stepi(false);
  }
 }

 public static void trace() {
  int start_off=0x86;

  trace(start_off);
 }
}
